/*
 * $Id: evreader.c,v 1.9 2008/08/04 13:19:33 oper Exp oper $
 *
 * evreader.c
 *
 * Christophe Lucas <clucas@infosat.tm.fr>
 * This file is under GPL terms.
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <errno.h>
#include <syslog.h>

#define VERSION "0.1"

#define EV_KEY	0x01


struct input_event {
	struct timeval time;
	unsigned short type;
	unsigned short code;
	unsigned int value;
};

void usage(void)
{
	printf("evreader v%d\n", VERSION);
	printf("\n");
	printf("evreader [path_to_poll] [shellscript_to_exec]\n");
}

int file_exist( char *file )
{
        extern int errno;
        int retval;
        struct stat st_file ;

        retval = stat(file, &st_file );
        if (retval == -1) {
                if (errno == ENOENT) {
                        return -1 ;
                } else {
                        printf("problme avec le fichier %s!!\n",file);
                }
        } else { return st_file.st_size ; }
}

int main(int argc, char** argv)
{
	int fd, flag;
	pid_t pid, sid;
	struct input_event tmpev;
	struct timeval oldtv;
	char cmd[255];

	if (argc != 3) {
		usage();
		return 255;
	}

	if (file_exist(argv[2]) < 0) {
		fprintf(stderr, "evreader: shell script to execute is not present.\n");
		return 255;
	} else {
		snprintf(cmd, 255, "/bin/bash %s", argv[2]);
	}

	fd = open(argv[1], O_RDONLY);
	if (fd < 0 ) {
		perror("evreader: open failed\n");
		return 255;
	}

	pid = fork();

	if (pid < 0) {
		exit(EXIT_FAILURE);
	} else if (pid > 0) {
		exit(EXIT_SUCCESS);
	}

	umask(0);

	sid = setsid();
	if (sid < 0) {
		exit(EXIT_FAILURE);
	}
	if ((chdir("/")) < 0) {
		exit(EXIT_FAILURE);
	}

	syslog(LOG_NOTICE, "evd started by User %d", getuid ());

	flag = 0;

	while (read(fd, &tmpev, sizeof(struct input_event)) > 0) {
		if (tmpev.type != 0) {
			if (tmpev.type == EV_KEY) {
				if (tmpev.value == 0) {
					oldtv = tmpev.time;
					flag = 1;
				}
				if (tmpev.value == 1) {
					if (flag == 1) {
						if (tmpev.time.tv_sec - oldtv.tv_sec >= 5) {
							syslog(LOG_NOTICE, "evd: cmd received to execute." );
							system(cmd);		
						}
						flag = 0;
					}
				}	
			}
		}
	}
	
	close(fd);
	return 0;
}

